#
#	Makefile for MSDOS with Turbo C 1.5/2.0 + Turbo Make
#

############################################################
# Character handling (select one from below)
CHAR	= SJIS
#CHAR	= BIT8
#CHAR	= NOKANJI

CC	= tcc -ml
CFLAGS	= -O -G -d -f- -DDOS -D$(CHAR)

OBJS =	main.obj alloc.obj cmdline.obj edit.obj fileio.obj help.obj \
	hexchars.obj linefunc.obj mark.obj misccmds.obj normal.obj \
	ops.obj param.obj ptrfunc.obj regexp.obj regsub.obj screen.obj \
	search.obj term.obj termcap.obj undo.obj version.obj glob.obj \
	dir.obj dos.obj fepctrl.obj setargv.obj

.c.obj:
	$(CC) -c $(CFLAGS) $*.c

all: stevie.exe ctags.exe

stevie.exe: $(OBJS)
	$(CC) -estevie *.obj

ctags.exe: ctags.c setargv.obj
	$(CC) ctags.c setargv.obj
	-del ctags.obj

clean:
	-del stevie.exe
	-del ctags.exe
	-del *.obj

main.obj:	stevie.h env.h ascii.h param.h
alloc.obj:	stevie.h env.h ascii.h param.h
cmdline.obj:	stevie.h env.h ascii.h param.h term.h
edit.obj:	stevie.h env.h ascii.h param.h term.h
fileio.obj:	stevie.h env.h ascii.h param.h
help.obj:	stevie.h env.h ascii.h param.h term.h
hexchars.obj:	stevie.h env.h ascii.h param.h
linefunc.obj:	stevie.h env.h ascii.h param.h
mark.obj:	stevie.h env.h ascii.h param.h
misccmds.obj:	stevie.h env.h ascii.h param.h term.h
normal.obj:	stevie.h env.h ascii.h keymap.h param.h ops.h
ops.obj:	stevie.h env.h ascii.h param.h ops.h
param.obj:	stevie.h env.h ascii.h param.h
ptrfunc.obj:	stevie.h env.h ascii.h param.h
regexp.obj:	env.h regexp.h regmagic.h
regsub.obj:	regexp.h regmagic.h
screen.obj:	stevie.h env.h ascii.h param.h term.h
search.obj:	stevie.h env.h ascii.h param.h regexp.h
term.obj:	stevie.h env.h ascii.h param.h term.h
termcap.obj:	env.h
undo.obj:	stevie.h env.h ascii.h param.h
glob.obj:	env.h dir.h
dir.obj:	dir.h
dos.obj:	stevie.h env.h ascii.h keymap.h param.h term.h
fepctrl.obj:	env.h fepctrl.h
