#
#	Makefile for OS/2 with Microsoft C 5.1 + MS-MAKE
#

##################################################################
# Character handling (select one from below)
CHAR	= SJIS
#CHAR	= BIT8
#CHAR	= NOKANJI

##################################################################
# Set full pathname of wildcard expander
#WILD	= a:\msc\lib\setargv.obj
WILD	=

CC	= cl -AL
CFLAGS	= -Os -Gs -DOS2 -D$(CHAR)

OBJS =	main.obj alloc.obj cmdline.obj edit.obj fileio.obj help.obj \
	hexchars.obj linefunc.obj mark.obj misccmds.obj normal.obj \
	ops.obj param.obj ptrfunc.obj regexp.obj regsub.obj screen.obj \
	search.obj term.obj termcap.obj undo.obj version.obj glob.obj \
	dir.obj os2.obj

main.obj: main.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) main.c

alloc.obj: alloc.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) alloc.c

cmdline.obj: cmdline.c stevie.h env.h ascii.h param.h term.h
	$(CC) -c $(CFLAGS) cmdline.c

edit.obj: edit.c stevie.h env.h ascii.h param.h term.h
	$(CC) -c $(CFLAGS) edit.c

fileio.obj: fileio.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) fileio.c

help.obj: help.c stevie.h env.h ascii.h param.h term.h
	$(CC) -c $(CFLAGS) help.c

hexchars.obj: hexchars.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) hexchars.c

linefunc.obj: linefunc.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) linefunc.c

mark.obj: mark.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) mark.c

misccmds.obj: misccmds.c stevie.h env.h ascii.h param.h term.h
	$(CC) -c $(CFLAGS) misccmds.c

normal.obj: normal.c stevie.h env.h ascii.h keymap.h param.h ops.h
	$(CC) -c $(CFLAGS) normal.c

ops.obj: ops.c stevie.h env.h ascii.h param.h ops.h
	$(CC) -c $(CFLAGS) ops.c

param.obj: param.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) param.c

ptrfunc.obj: ptrfunc.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) ptrfunc.c

regexp.obj: regexp.c env.h regexp.h regmagic.h
	$(CC) -c $(CFLAGS) regexp.c

regsub.obj: regsub.c regexp.h regmagic.h
	$(CC) -c $(CFLAGS) regsub.c

screen.obj: screen.c stevie.h env.h ascii.h param.h term.h
	$(CC) -c $(CFLAGS) screen.c

search.obj: search.c stevie.h env.h ascii.h param.h regexp.h
	$(CC) -c $(CFLAGS) search.c

term.obj: term.c stevie.h env.h ascii.h param.h term.h
	$(CC) -c $(CFLAGS) term.c

termcap.obj: termcap.c env.h
	$(CC) -c $(CFLAGS) termcap.c

undo.obj: undo.c stevie.h env.h ascii.h param.h
	$(CC) -c $(CFLAGS) undo.c

version.obj: version.c
	$(CC) -c $(CFLAGS) version.c

glob.obj: glob.c env.h dir.h
	$(CC) -c $(CFLAGS) glob.c

dir.obj: dir.c dir.h
	$(CC) -c $(CFLAGS) dir.c

os2.obj: os2.c stevie.h env.h ascii.h keymap.h param.h term.h
	$(CC) -c $(CFLAGS) os2.c

stevie.exe: $(OBJS)
	$(CC) *.obj $(WILD) -o stevie.exe /F 6000 -link /E/NOE

ctags.exe: ctags.c
	$(CC) ctags.c $(WILD) -o ctags.exe -link /E/NOE
	cmd /c del ctags.obj
