#
#   Makefile for PC-9801 with Turbo C 1.5/2.0 + MASM/TASM + Turbo Make
#

#########################################################
# For VRAM version
#SYS	= PC98_VRAM
#SYSOBJ	=
#SYSINC	=

#########################################################
# For VRAM + mouse version
SYS	= PC98_MOUSE
SYSOBJ	= pc98_mou.obj
SYSINC	= pc98_mou.h

#########################################################
# For GVRAM 50 line version
#SYS	= PC98_50LINE
#SYSOBJ	= pc98_50l.obj
#SYSINC	= pc98_50l.inc

CC	= tcc -ml
CFLAGS	= -O -G -d -f- -D$(SYS) -DSJIS
AS	= masm
#AS	= tasm
ASFLAGS	= /Mx

OBJS =	main.obj alloc.obj cmdline.obj edit.obj fileio.obj help.obj \
	hexchars.obj linefunc.obj mark.obj misccmds.obj normal.obj \
	ops.obj param.obj ptrfunc.obj regexp.obj regsub.obj screen.obj \
	search.obj undo.obj version.obj glob.obj dir.obj dos.obj \
	fepctrl.obj $(SYSOBJ) setargv.obj

.c.obj:
	$(CC) -c $(CFLAGS) $*.c

.asm.obj:
	$(AS) $(ASFLAGS) $*.asm;

all: stevie.exe ctags.exe

stevie.exe: $(OBJS)
	$(CC) -estevie *.obj

ctags.exe: ctags.c setargv.obj
	$(CC) ctags.c setargv.obj
	-del ctags.obj

pc98_cbm.exe: pc98_cbm.c
	$(CC) pc98_cbm.c
	-del pc98_cbm.obj

pc98_cbm.h: pc98_cbm.dat pc98_cbm.exe
	pc98_cbm pc98_cbm.dat pc98_cbm.h

clean:
	-del stevie.exe
	-del ctags.exe
	-del pc98_cbm.exe
	-del pc98_cbm.h
	-del *.obj

main.obj:	stevie.h env.h ascii.h param.h
alloc.obj:	stevie.h env.h ascii.h param.h
cmdline.obj:	stevie.h env.h ascii.h param.h term.h
edit.obj:	stevie.h env.h ascii.h param.h term.h
fileio.obj:	stevie.h env.h ascii.h param.h
help.obj:	stevie.h env.h ascii.h param.h term.h
hexchars.obj:	stevie.h env.h ascii.h param.h
linefunc.obj:	stevie.h env.h ascii.h param.h
mark.obj:	stevie.h env.h ascii.h param.h
misccmds.obj:	stevie.h env.h ascii.h param.h term.h
normal.obj:	stevie.h env.h ascii.h keymap.h param.h ops.h
ops.obj:	stevie.h env.h ascii.h param.h ops.h
param.obj:	stevie.h env.h ascii.h param.h
ptrfunc.obj:	stevie.h env.h ascii.h param.h
regexp.obj:	env.h regexp.h regmagic.h
regsub.obj:	regexp.h regmagic.h
screen.obj:	stevie.h env.h ascii.h param.h term.h
search.obj:	stevie.h env.h ascii.h param.h regexp.h
undo.obj:	stevie.h env.h ascii.h param.h
glob.obj:	env.h dir.h
dir.obj:	dir.h
dos.obj:	stevie.h env.h ascii.h keymap.h param.h term.h $(SYSINC)
fepctrl.obj:	env.h fepctrl.h
pc98_mou.obj:	stevie.h env.h pc98_mou.h pc98_cbm.h
