/* $Header: /nw/tony/src/stevie/src/RCS/term.c,v 1.4 89/03/11 22:43:55 tony Exp $
 *
 * Termcap initialization (optional).
 */

#include <stdio.h>
#include "stevie.h"

#ifdef	TERMCAP

#define	TBSIZE	1024	/* size of termcap buffer (termcap dependent) */
#define	CBSIZE	256	/* maximum size of capability buffer */

static	char	buf[TBSIZE];	/* termcap entry read here */
static	char	cap[CBSIZE];	/* capability strings go in here */

char	*T_CM;		/* cursor motion string */
char	*T_EL;		/* erase the entire current line */
char	*T_ED;		/* erase display (may optionally home cursor) */
char	*T_EB;		/* erase to the end of display */
char	*T_IL;		/* insert one line */
char	*T_DL;		/* delete one line */
char	*T_IM;		/* insert multiple lines */
char	*T_DM;		/* delete multiple lines */
char	*T_SC;		/* save the cursor position */
char	*T_RC;		/* restore the cursor position */
char	*T_SO;		/* begin standout mode (optional) */
char	*T_SE;		/* end standout mode (optional) */
char	*T_US;		/* begin underline mode (optional) */
char	*T_UE;		/* end underline mode (optional) */
char	*T_CI;		/* invisible cursor (very optional) */
char	*T_CV;		/* visible cursor (very optional) */
char	*T_TI;		/* initialize termcap (very optional) */
char	*T_TE;		/* end termcap (very optional) */
/*
 * capabilities below are used only with termcap
 */
char	*T_CS;		/* change scroll region (used if no T_IL, T_DL) */
char	*T_SF;		/* scroll forward (used with T_CS) */
char	*T_SR;		/* scroll reverse (used with T_CS) */

/*
 * terminal output padding information
 */
short	ospeed;		/* output speed for terminal */
char	PC = 0;		/* padding character (if not NUL) */

extern	int	tgetent(), tgetnum();
extern	char	*tgetstr();
extern	char	*getenv();

int
t_init()
{
	char	*term, *p;
	int	n;
	char	*cp = cap;

	if ((term = getenv("TERM")) == NULL)
		return -1;

	if (tgetent(buf, term) != 1)
		return -1;

	if ((n = tgetnum("li")) == -1)
		return 0;
	else
		P(P_LI) = Rows = n;

	if ((n = tgetnum("co")) == -1)
		return 0;
	else
		Columns = n;

	/*
	 * Get mandatory capability strings.
	 */
	T_CM = tgetstr("cm", &cp);
	T_EL = tgetstr("ce", &cp);
	T_ED = tgetstr("cl", &cp);

	if (T_CM == NULL || T_EL == NULL || T_ED == NULL)
		return 0;

	/*
	 * Optional capabilities.
	 */
	T_EB = tgetstr("cd", &cp);
	T_IL = tgetstr("al", &cp);
	T_DL = tgetstr("dl", &cp);
	T_IM = tgetstr("AL", &cp);
	T_DM = tgetstr("DL", &cp);
	T_SC = tgetstr("sc", &cp);
	T_RC = tgetstr("rc", &cp);
	T_SO = tgetstr("so", &cp);
	T_SE = tgetstr("se", &cp);
	T_US = tgetstr("us", &cp);
	T_UE = tgetstr("ue", &cp);
	T_CI = tgetstr("vi", &cp);
	T_CV = tgetstr("ve", &cp);
	T_TI = tgetstr("ti", &cp);
	T_TE = tgetstr("te", &cp);
	T_CS = tgetstr("cs", &cp);
	T_SF = tgetstr("sf", &cp);
	T_SR = tgetstr("sr", &cp);

	if (T_CS && !T_SF)
		T_SF = "\n";

	if ((p = tgetstr("pc", &cp)) != NULL)
		PC = *p;

	return 1;
}

#endif
